package com.pgmriver.android;

import java.nio.FloatBuffer;

import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLU;

public class GLViewSecond extends BaseGLView {

	public GLViewSecond(Context context) {
		super(context);
		mFloatBuffer = makeFloatBuffer(square);
	}

	protected void init(GL10 gl)
	{
		gl.glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
		
		gl.glMatrixMode(GL10.GL_PROJECTION);
		gl.glLoadIdentity();
		GLU.gluOrtho2D(gl, 0.0f, 1.2f, 0.0f, 1.0f);
	}
	
	@Override
	protected void drawFrame(GL10 gl) {
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);
		
		gl.glMatrixMode(GL10.GL_MODELVIEW);
		gl.glLoadIdentity();
		gl.glTranslatef(0, 0, -1);
		
		gl.glColor4f(1, 0, 0, 0.5f);
		gl.glVertexPointer(3, GL10.GL_FLOAT, 0, mFloatBuffer);
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
		gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, 0, 4);
	}
	
	float[] square = new float[]{
		-0.25f, -0.25f, 0.0f,
		0.25f, -0.25f, 0.0f,
		-0.25f, 0.25f, 0.0f,
		0.25f, 0.25f, 0.0f };
	
	FloatBuffer mFloatBuffer;
}
