package com.pgmriver.android;

import java.nio.FloatBuffer;

import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLU;

public class GLViewThird extends BaseGLView {

	public GLViewThird(Context context) {
		super(context);
		// TODO Auto-generated constructor stub
		
		mTriangleBuffer = makeFloatBuffer(triangle);
		mColorBuffer = makeFloatBuffer(colors);
	}
	
	@Override
	protected void init(GL10 gl)
	{
		gl.glClearColor(0, 0, 0, 0);
		
		// 投影行列(GL_PROJECTION)を変更する宣言
		gl.glMatrixMode(GL10.GL_PROJECTION);
		
		// 投影行列を正規化しておく
		gl.glLoadIdentity();
		
		// 正投影(z無視)
		// 2次元座標をスクリーンに投影する行列を作成し、
		// カレントの投影行列と乗算する
		// left, right, bottom, top
		// 左下(left, bottom), 右上(right, top)の矩形を
		// クリッピング領域とする
		GLU.gluOrtho2D(gl, 0, 1.3f, 0, 1.0f);
		
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT);
		
		gl.glShadeModel(GL10.GL_SMOOTH);
	}

	@Override
	protected void drawFrame(GL10 gl) {
		// TODO Auto-generated method stub
		gl.glClear(GL10.GL_COLOR_BUFFER_BIT | GL10.GL_DEPTH_BUFFER_BIT);
		gl.glMatrixMode(GL10.GL_MODELVIEW);
		gl.glLoadIdentity();
		gl.glTranslatef(0, 0, -1);
		
		// send the vertices to the renderer
		/*
		gl.glVertexPointer(3, GL10.GL_FLOAT, 0, triangleBuff);
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
	
		// Send the colors to the renderer
		gl.glColorPointer(4, GL10.GL_FLOAT, 0, colorBuff);
		gl.glEnableClientState(GL10.GL_COLOR_ARRAY);
		
		gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, 0, 3);
		*/
		
		gl.glVertexPointer(3, GL10.GL_FLOAT, 0, mTriangleBuffer);
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
		
		// send the colors to the renderer
		gl.glColorPointer(4, GL10.GL_FLOAT, 0, mColorBuffer);
		gl.glEnableClientState(GL10.GL_COLOR_ARRAY);
		
		gl.glDrawArrays(GL10.GL_TRIANGLE_STRIP, 0, 3);
	}

	FloatBuffer mTriangleBuffer;
	FloatBuffer mColorBuffer;

	// Vertices (x,y,z) for a 2D triangle
	float[] triangle = new float[]{
			-0.25f, -0.25f, 0.0f,
			0.25f, -0.25f, 0.0f,
			-0.25f, 0.25f, 0.0f};
	
	// Colors (r,g,b,a) for each vertex
	float[] colors = new float[]{
			1, 0, 0, 1,
			0, 1, 0, 1,
			0, 0, 1, 1};
}
